-- 不是很懂为什么要把macro放主线文件夹。 这个地方放我自己要用的macro。

DAMAGE_SCALE = 1 --global变量 存储普攻伤害放大倍率

function IsNpc(tid)
	return tid>512
end

function IsPlayer(tid)
	if not tid then
		global.Print(debug.traceback())
	end
	return tid<=512
end

function randround(x) --随机型取整
	local int_part = math.floor(x)
	local frac_part = x - int_part
	assert (0 <= frac_part and frac_part < 1)
	if math.random() < frac_part then
		int_part = int_part + 1
	end
	return int_part
end

function math.round(x) -- 四舍五入函数
	return x >= 0 and math.floor(x+0.5) or math.ceil(x-0.5)
end

function math.log2(x) -- 主角ID->主角位次
	local id = 1
	local n = 0
	for i = 1, 11 do
		if id == x then 
			return n
		end
		id = id * 2
		n = n + 1
	end
end

function table.contains(t, x) 
	for _, v in pairs(t) do
		if v == x then
			return true
		end
	end
	return false
end

function GetPlayersInTeam() --获取队伍中所有玩家
	local ps = {}
	for i=0,9 do
		local pid = 2^i
		if player.IsPlayerInTeam(pid) == 1 then
			table.insert(ps, pid)
		end
	end
	return ps
end

function GetPlayersInBattle() --获取战场上所有玩家(活着的)
	local ps = {}
	for wid=1,9,1 do
		if battle.CheckPlayerPlace(wid)==1  then
		   table.insert(ps,battle.GetPlacePlayerID(wid))
		end
	end
	return ps
end

function GetEnemies() -- 获取战场上所有敌人(活着的)
	local ns = {}
	for i=1,7 do
		if battle.CheckNpcPlace(i)==0 then
			table.insert(ns, battle.GetPlaceNpcID(i))
		end
	end
	return ns
end

function CheckStat(tid, stateId)
	if IsPlayer(tid) then
		return battle.CheckPlayerStat(tid, stateId) == 1
	else
		return battle.CheckNpcStat(tid, stateId) == 1
	end
end

state_replace = { --状态取代表。施加状态会使表中其他状态消失
	[91] = {96,0}, [92] = {96,0}, [93] = {96,0}, [94] = {96,0}, [95] = {96,0}, --灼热取消冰冻和冰封
	[96] = {91,92,93,94,95},  -- 冰封取代灼热
	
}

state_fail = { --状态施加不能表。施加状态会失败，如果已有表中状态
	[96] = {96, 0},  --冰封不能延长
}

function AddStat(tid, prob, stateId, round) --返回true/false是否施加成功
	local stfa = state_fail[stateId]
	if stfa then --不能施加状态
		for _, st in ipairs(stfa) do
			if CheckStat(tid, st) then
				return false
			end
		end
	end
	local resis = GetStateResistance(tid, stateId)
	
	prob = prob - resis
	if battle.GetRndNumber(1, 100) > prob then
		return false
	end
	--法障结算
	if CheckStat(tid, 13) and stateId < 10 then
		round = randround(round * 0.8)
		if round == 0 then
			return false
		end
	end
	if IsPlayer(tid) then
		player.AddStat(0,tid,999,stateId,round)
	else
		npc.AddStat(0,tid,999,stateId,round)
	end
	local stre = state_replace[stateId]
	if stre then --替换已有状态
		for _, st in ipairs(stre) do
			RemoveStat(tid, st)
		end
	end
	return CheckStat(tid, stateId) --系统内部互斥判定
	
end

function RemoveStat(tid, stateId)
	if IsPlayer(tid) then
		player.RemoveStat(0,tid,stateId)
	else
		npc.RemoveStat(tid,stateId)
	end
end

function ChangeHP(tid, value, critical, noanim, from_wind) 
-- critical为true则显示暴击扣血(需打开暴击功能), noanim表示没有扣血动作, from_wind表示伤害来自风属性
	local last_arg = 0
	
	if critical then last_arg = last_arg + 2 end
	
	value = randround(value)
	if value ~= 0 then
		if IsPlayer(tid) then
			if noanim then last_arg = last_arg + 1 end
			player.ChangeHP(0,0,tid,value,last_arg)
		else
			if noanim then
				global.Print("No anim not supported in npc.ChangeHP")
			end
			npc.ChangeHP(0,last_arg,tid,value)
			if not from_wind and value < 0 then
				local reduce_lv = math.floor(-value/GetMaxHP(tid)/0.03)
				--风系被动，每减少3%生命值，层数减1
				AddPiJuan(tid, -reduce_lv)
			end
		end
	end
	

end

function GetHP(tid)
	if IsPlayer(tid) then 
		return player.GetHP(tid, 0) 
	else 
		return npc.GetHP(tid, 0) 
	end
end

function GetMaxHP(tid)
	if IsPlayer(tid) then 
		return player.GetMaxHP(tid) 
	else 
		return npc.GetMaxHP(tid) 
	end
end

function GetAtk(tid) 
	local atk
	if IsPlayer(tid) then 
		atk = player.GetAtk(tid)
	else
		atk = npc.GetAtk(tid)
	end
	if CheckStat(tid, 10) then --强袭
		atk = atk * 1.1 + 10
	end
	if CheckStat(tid, 3) then -- 脱力变一半
		atk = atk / 2
	end 
	return atk
end

function GetDef(tid)
	local def 
	if IsPlayer(tid) then 
		def = player.GetDef(tid)
	else
		def = npc.GetDef(tid)
	end
	if CheckStat(tid, 11) then --坚盾
		def = def * 1.25
	end
	return def
end

function GetMagicAtk(tid)
	local matk
	if IsPlayer(tid) then 
		matk = player.GetMagicAtk(tid)
	else
		matk = npc.GetMagicAtk(tid)
	end
	if CheckStat(tid, 3) then -- 脱力变一半
		matk = matk / 2
	end 
	return matk
end

function GetMagicDef(tid)
	local def
	if IsPlayer(tid) then 
		def = player.GetMagicDef(tid)
	else
		def = npc.GetMagicDef(tid)
	end
	if CheckStat(tid,13) then --法障
		def = def * 1.2
	end
	if CheckStat(tid,82) then --破仙
		def = def * 0.75
	end
	return def
end

function GetHit(tid)
	if IsPlayer(tid) then 
		return player.GetHit(tid)
	else
		return npc.GetHit(tid)
	end
end

function GetMiss(tid)
	if CheckStat(tid, 0) or CheckStat(tid, 5) then
		return 0
	end
	if IsPlayer(tid) then 
		return player.GetMiss(tid)
	else
		return npc.GetMiss(tid)
	end
end

function GetBlock(tid)
	if CheckStat(tid, 0) or CheckStat(tid, 5) or IsNpc(tid) then
		return 0
	else 
		return player.GetBlock(tid)
	end
end

function GetCritical(tid)
	if IsPlayer(tid) then 
		return player.GetCritical(tid)
	else
		return npc.GetCritical(tid)
	end
end

function GetCombo(tid)
	if IsPlayer(tid) then 
		return player.GetCombo(tid)
	else
		return 0 --npc没连击
	end
end

function GetMagicBonus(tid, attr)
	if IsPlayer(tid) then 
		return player.GetMagicBonus(tid, attr)
	else
		return 0 -- npc没有
	end
end

function GetMagicResistance(tid, attr)
	if attr == -1 or attr == 6 then return 0 end --阳抗性和物理抗性
	local resis
	if IsPlayer(tid) then 
		resis = player.GetMagicResistance(tid, attr)
	else
		resis = npc.GetMagicResistance(tid, attr)
		if attr == 4 then --土
			resis = resis - GetEarthResisReduceLevel(tid) * 0.1
		end
	end
	return resis
end

function GetStateResistance(tid, attr)
	if attr > 9 then return 0 end
	if IsPlayer(tid) then 
		return player.GetStateResistance(tid, attr)
	elseif attr > 0 then
		return npc.GetStateResistance(tid, attr)
	end
	-- 敌人的冻结
	local origin_resis = npc.GetStateResistance(tid, 0)
	if origin_resis < 0 then
		return origin_resis
	end
	local flag_id = tid - 30000
	local bingfenglv = flag.GetBattleValue(flag_id)
	return math.round(origin_resis * 0.8 ^ bingfenglv)
end

function GetXiuWei(tid, attr)
	if IsPlayer(tid) and attr ~= -1 and attr ~= 7 then
		return player.GetXiuWei(tid, attr)
	else
		return 0
	end
end

function GetWeapon(tid)
	if IsPlayer(tid) then
		return player.GetWeapon(tid)
	else
		return 0
	end
end

function GetWeakestPlayer() --获取当前战斗中最弱的玩家(挑最软的攻击)
	local minhp = 99999
	local minhp_p
	for _,p in ipairs(GetPlayersInBattle()) do
		local hp = GetHP(p) --目前获取血量最少者
		if CheckStat(p,6) then --有异变的角色看作只有一半血
			hp = hp /2 
		end
		if CheckStat(p, 11) or CheckStat(p,13) then --有坚盾或法障则看作血更多
			hp = hp * 1.3
		end
		if hp < minhp and hp >0 then
			minhp = hp
			minhp_p = p
		end
	end
	return minhp_p
end

function GetRndPlayer(prob) -- AI中用来获取随机玩家
-- prob 表示AI的智能程度(0-1) With prob. (1-prob)真·随机攻击
	if not prob then prob = 0.5 end
	if math.random() < prob then
		return GetWeakestPlayer()
	end
	local ps = GetPlayersInBattle()
	return ps[math.random(#ps)]
end
 
function GetRealDamage( tid, dmg, attr, def) -- 求sid对tid造成属性attr的dmg点伤害等价于多少真实伤害
-- attr = {-1,0,1,...,7} -> {物理，雷风水火土阴阳无}
-- def 有时需要指定敌方def(破甲)

if attr == -1 then -- 物理伤害
	if not def then def = GetDef(tid) end

	
	if IsPlayer(tid) then --被攻击者为玩家
		if player.CheckFuZhou(tid,450) then dmg = dmg * 0.9 end --钢盾一0.9倍伤害
		if player.CheckFuZhou(tid,451) then dmg = dmg * 0.8 end --钢盾二0.8倍伤害
	end

else --仙术伤害
	if not def then def = GetMagicDef(tid) end
	dmg = dmg * (1 - GetMagicResistance(tid, attr)) --抗性减伤
	
end

dmg = dmg * 250/(250+def)  --防御减伤
return dmg

end

function CauseDamage(tid, dmg, attr, def, critical) -- 造成属性伤害
	if attr == -1 and CheckStat(tid, 97) then --石化转属性
		attr = 4
	end
	local dmg = GetRealDamage(tid, dmg, attr, def)
	ChangeHP(tid, -dmg, critical, false, attr == 1)
end

function skill_dmg(tid, dmg, attr, critical) -- dmg基础伤害值(ad/ap加成作用在dmg后传入)
-- attr = -1,0,1,...,7: 物理, 雷风水火土阴阳无
	local sid = battle.GetActingPlayerID()
	dmg = dmg * (1 + GetMagicBonus(sid, attr)) --属性加成
	dmg = dmg * (1 + GetXiuWei(sid, attr) / 3000) -- 修为加成  
	dmg = dmg * battle.GetRndNumber(250, 262) / 256 -- 随机因子
	if attr == 6 then --治疗
		ChangeHP(tid, dmg)
	else
		CauseDamage(tid, dmg, attr, nil, critical)
	end
end

function AtkToPlayer(tid, animID, scale)
	if not scale then scale = 1 end
	DAMAGE_SCALE = scale
	battle.AtkToPlayer(tid, animID)
end



---------------技能/仙术专用---------------
---大招充能---
function RoundCharge(tid) --回合开始的大招冷却充能
	local i = math.log2(tid)
	local v = flag.GetBattleValue(50000 + i)
	if v <= 0 then 
		AddStat(tid, 100, 999, 100)
		return 
	end
	local charge_speed = 100 --充能速度，将要修改
	v = v - charge_speed 
	flag.SetBattleValue(50000 + i, v)
	if v <= 0 then
		ui.Message(90001) --大招充能完毕
		AddStat(tid, 100, 999, 100)
	end
end

function IsChargeFinished(tid) --是否充能完毕
	local i = math.log2(tid)
	local v = flag.GetBattleValue(50000 + i)
	return v <= 0
end


function CoolDown(tid, cd) -- 使用大招后结算冷却
	local i = math.log2(tid)
	local v = flag.GetBattleValue(50000 + i)
	v = v + cd
	flag.SetBattleValue(50000 + i, v)
	RemoveStat(tid, 999)
	return true
end

---火系被动---
function GetZhuoReLevel(tid) --获得目标身上的灼热层数
	local flag_id = tid - 29700
	return flag.GetBattleValue(flag_id)
end

function AddZhuoRe(tid, n) -- 给目标增加n层灼热(可以填负数)
	local lv = GetZhuoReLevel(tid)
	local flag_id = tid - 29700
	local newlv = lv + n
	newlv = math.max(math.min(newlv, 5), 0) --必须是0~5层
	flag.SetBattleValue(flag_id, newlv)
	if newlv == 0 then
		RemoveStat(tid, 91)
	else
		AddStat(tid, 100, 91, 100)
	end
end

function RoundZhuoRe(id) -- 回合开始结算灼热效果
	local lv = GetZhuoReLevel(id)
	if lv == 5 then --爆炸
		AddZhuoRe(id, -5)
		local dmg = GetMaxHP(id) / 10
		local targets
		if IsPlayer(id)  then
			targets = GetPlayersInBattle()
		else
			targets = GetEnemies()
		end
		
		for _, tid in pairs(targets) do
			if tid == id then --爆炸自身受到10%最大生命值魔法伤害
				CauseDamage(tid, dmg, 3)
			else --其他敌人受到1/10伤害
				CauseDamage(tid, dmg/10, 3)
			end
		end
	elseif lv > 0 then -- 普通灼烧, 2%最大生命值
		AddZhuoRe(id, -1)
		CauseDamage(id, GetMaxHP(id) / 50, 3)
	end
end

---水系被动---
function AddBingFeng(tid) --使用水系仙术时
	local flag_id = tid - 30000
	local v = flag.GetBattleValue(flag_id)
	AddStat(tid, 100, 96, 3) --如果已经冰封不会再施加，不用担心
	flag.SetBattleValue(flag_id, v + 1)
end

function ResetBingFeng(tid) --冰封状态消失时
	local flag_id = tid - 30000
	flag.SetBattleValue(flag_id, 0)
end

--雷系被动--
function GetQuickness(tid) -- 获取当前身法
	if IsPlayer(tid) then
		return player.GetQuickness(tid) 
	else
		return battle.GetNpcSpeed(tid)
	end
end

function GetOriginQuickness(tid) -- 获取npc原版身法
	local flag_id = tid - 29900
	local v = flag.GetBattleValue(flag_id)
	if v == 0 then
		v = GetQuickness(tid)
		flag.SetBattleValue(flag_id, v)
	end
	return v
end

function SetQuickness(tid, q) -- 调整npc身法
	if IsPlayer(tid) then
		global.Print("Cannot set player's Quickness.")
	end
	if q < 1 then q = 1 end --以防万一
	local flag_id = tid - 29900 -- 凡是修改身法必定调用 这样就保证原版身法不会储存错误
	local v = flag.GetBattleValue(flag_id)
	if v == 0 then
		v = GetQuickness(tid)
		flag.SetBattleValue(flag_id, v)
	end
	battle.SetNpcSpeed(tid, q)
end

--土系大招--
function GetEarthResisReduceLevel(tid) -- 获取土抗性减少层数(每层减少10)
	local flag_id = tid - 29800
	return flag.GetBattleValue(flag_id)
end

function AddEarthResisReduceLevel(tid) -- 增加一层土抗性减少层数
	local flag_id = tid - 29800
	local v = flag.GetBattleValue(flag_id)
	flag.SetBattleValue(flag_id, v+1)
end

---风系被动---
function GetPiJuanLevel(tid) --获得目标身上的疲倦层数
	local flag_id = tid - 29600
	return flag.GetBattleValue(flag_id)
end

function AddPiJuan(tid, n) -- 给目标增加n层疲倦(可以填负数)
	local flag_id = tid - 29600
	if n > 0 and CheckStat(tid, 5) then --昏睡下不能增加疲倦
		return
	end
	local lv = GetPiJuanLevel(tid)
	local newlv = lv + n
	newlv = math.max(math.min(newlv, 9), 0) --必须是0~9层
	flag.SetBattleValue(flag_id, newlv)
	if newlv == 0 then
		RemoveStat(tid, 92)
	else
		AddStat(tid, 100, 92, 100)
	end
end